Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class StackTraceElement

    java.lang.Object
      java.lang.StackTraceElement

All Implemented Interfaces:
  Serializable

    public final class StackTraceElement

extends Object
implements Serializable

An element in a stack trace, as returned by `Throwable.getStackTrace()`. Each element represents a single stack frame. All stack frames except for the one at the top of the stack represent a method invocation. The frame at the top of the stack represents the execution point at which the stack trace was generated. Typically, this is the point at which the throwable corresponding to the stack trace was created.

Since:
  1.4
See Also:
  Serialized Form

Constructor Summary
`StackTraceElement(String declaringClass, String methodName, String fileName, int lineNumber)` Creates a stack trace element representing the specified execution point.

Method Summary
`boolean` | `equals(Object obj)` Returns true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance.
`String` | `getClassName()` Returns the fully qualified name of the class containing the execution point represented by this stack trace element.
`String` | `getFileName()` Returns the name of the source file containing the execution point represented by this stack trace element.
`int` | `getLineNumber()` Returns the line number of the source line containing the execution point represented by this stack trace element.
`String` | `getMethodName()` Returns the name of the method containing the execution point represented by this stack trace element.
`int` | `hashCode()` Returns a hash code value for this stack trace element.
`boolean` | `isNativeMethod()` Returns true if the method containing the execution point represented by this stack trace element is a native method.
`String` | `toString()` Returns a string representation of this stack trace element.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### StackTraceElement

    public StackTraceElement(String declaringClass,
                             String methodName,
                             String fileName,
                             int lineNumber)

  Creates a stack trace element representing the specified execution point.

  Parameters:
    `declaringClass` - the fully qualified name of the class containing the execution point represented by the stack trace element
    `methodName` - the name of the method containing the execution point represented by the stack trace element
    `fileName` - the name of the file containing the execution point represented by the stack trace element, or `null` if this information is unavailable
    `lineNumber` - the line number of the source line containing the execution point represented by this stack trace element, or a negative number if this information is unavailable. A value of -2 indicates that the method containing the execution point is a native method
  Throws:
    `NullPointerException` - if `declaringClass` or `methodName` is null
  Since:
    1.5

Method Detail

### getFileName

    public String getFileName()

  Returns the name of the source file containing the execution point represented by this stack trace element. Generally, this corresponds to the `SourceFile` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.7). In some systems, the name may refer to some source code unit other than a file, such as an entry in source repository.

  Returns:
    the name of the file containing the execution point represented by this stack trace element, or `null` if this information is unavailable.

### getLineNumber

    public int getLineNumber()

  Returns the line number of the source line containing the execution point represented by this stack trace element. Generally, this is derived from the `LineNumberTable` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.8).

  Returns:
    the line number of the source line containing the execution point represented by this stack trace element, or a negative number if this information is unavailable.

### getClassName

    public String getClassName()

  Returns the fully qualified name of the class containing the execution point represented by this stack trace element.

  Returns:
    the fully qualified name of the `Class` containing the execution point represented by this stack trace element.

### getMethodName

    public String getMethodName()

  Returns the name of the method containing the execution point represented by this stack trace element. If the execution point is contained in an instance or class initializer, this method will return the appropriate special method name, `<init>` or `<clinit>`, as per Section 3.9 of The Java Virtual Machine Specification.

  Returns:
    the name of the method containing the execution point represented by this stack trace element.

### isNativeMethod

    public boolean isNativeMethod()

  Returns true if the method containing the execution point represented by this stack trace element is a native method.

  Returns:
    `true` if the method containing the execution point represented by this stack trace element is a native method.

### toString

    public String toString()

  Returns a string representation of this stack trace element. The format of this string depends on the implementation, but the following examples may be regarded as typical:
  - `"MyClass.mash(MyClass.java:9)"` - Here, `"MyClass"` is the fully-qualified name of the class containing the execution point represented by this stack trace element, `"mash"` is the name of the method containing the execution point, `"MyClass.java"` is the source file containing the execution point, and `"9"` is the line number of the source line containing the execution point.
  - `"MyClass.mash(MyClass.java)"` - As above, but the line number is unavailable.
  - `"MyClass.mash(Unknown Source)"` - As above, but neither the file name nor the line number are available.
  - `"MyClass.mash(Native Method)"` - As above, but neither the file name nor the line number are available, and the method containing the execution point is known to be a native method.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.
  See Also:
    `Throwable.printStackTrace()`

### equals

    public boolean equals(Object obj)

  Returns true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance. Two stack trace elements `a` and `b` are equal if and only if:

           equals(a.getFileName(), b.getFileName()) &&
           a.getLineNumber() == b.getLineNumber()) &&
           equals(a.getClassName(), b.getClassName()) &&
           equals(a.getMethodName(), b.getMethodName())

  where `equals` is defined as:

           static boolean equals(Object a, Object b) {
               return a==b || (a != null && a.equals(b));
           }

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the object to be compared with this stack trace element.
  Returns:
    true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hash code value for this stack trace element.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.